=== test/others/action-script/Makefile ===
run:
	@make -C .. loop
	./run.sh

.PHONY: run
