=== debian/changelog ===
criu (4.0-4) unstable; urgency=medium

  * debian/t/integration-tests: Don't exit immediately on command failues
    (Closes: #1100056)
  * Declare compliance with Debian policy 4.7.2
  * Add Build-Depends on python3-setuptools

 -- Salvatore Bonaccorso <carnil@debian.org>  Mon, 10 Mar 2025 23:36:59 +0100

criu (4.0-3) unstable; urgency=medium

  * debian/control: libcriu2: Add Depends on criu
  * Update copyright years for debian/* packaging files

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 09 Jan 2025 22:38:41 +0100

criu (4.0-2) unstable; urgency=medium

  * d/t/integration-tests: Retry testsuite on failure to check for flaky tests

 -- Salvatore Bonaccorso <carnil@debian.org>  Wed, 11 Dec 2024 14:18:03 +0100

criu (4.0-1) unstable; urgency=medium

  * Upload to unstable

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 05 Dec 2024 21:07:07 +0100

criu (4.0-1~exp1) experimental; urgency=medium

  * New upstream version 4.0
  * debian/not-installed: Do not (yet) install the cuda plugin.
  * libcompel1: amd64: Add new symbols from 4.0 upstream version

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 29 Nov 2024 18:39:10 +0100

criu (3.19-7) unstable; urgency=medium

  * debian/control: Fix test-name for autopkgtest-pkg-python
  * debian/control: Mark libcriu2 and libcompel1 with Multi-Arch: same
  * d/t/integration-tests: Enable netns_lock_iptables test
  * net: fix network unlock with iptables-nft

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 29 Nov 2024 10:59:12 +0100

criu (3.19-6) unstable; urgency=medium

  * d/t/integration-tests: Enable rseq tests in autopkgtest run
  * Adjust to glibc __rseq_size semantic change
  * d/t/integration-tests: Enable scm06 tests in autopkgtest run

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 24 Nov 2024 07:49:05 +0100

criu (3.19-5) unstable; urgency=medium

  * Add Replaces and Breaks relations for the package split into multiple
    binary packages (Closes: #1087819)

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 19 Nov 2024 08:57:37 +0100

criu (3.19-4) unstable; urgency=medium

  * libcompel1: Add architecture specific symbols files

 -- Salvatore Bonaccorso <carnil@debian.org>  Mon, 18 Nov 2024 08:59:28 +0100

criu (3.19-3) unstable; urgency=medium

  [ Salvatore Bonaccorso ]
  * debian/rules: Remove --ddeb-migration for a old version of criu

  [ Reinhard Tartler ]
  * Split into multiple packages (Closes: #782007)

 -- Salvatore Bonaccorso <carnil@debian.org>  Mon, 18 Nov 2024 06:46:54 +0100
